#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& in1) {
    size_t number_count;
    cerr << "Enter number count: ";
    in1 >> number_count;

    Input in;

    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        in1 >> in.numbers[i];
    }

    cerr << "Enter number bin: ";
    in1 >> in.bin_count;

    return in;
}



int main()
{
    auto in = input_data(cin);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);
    //show_histogram_svg(bins);
    return 0;
}
